import { ImportDeclaration } from 'typescript';
import { ComponentMetadata } from '@aws-amplify/codegen-ui';
import { ImportValue, ImportSource } from './import-mapping';
export declare class ImportCollection {
    #private;
    constructor(componentMetadata?: ComponentMetadata);
    importedNames: Set<string>;
    importAlias: Map<string, Map<string, string>>;
    addMappedImport(importValue: ImportValue): void;
    addImport(packageName: string, importName: string): string;
    removeImportSource(packageImport: ImportSource): void;
    getMappedAlias(packageName: string, importName: string): string;
    mergeCollections(otherCollection: ImportCollection): void;
    buildSampleSnippetImports(topComponentName: string): ImportDeclaration[];
    getAliasMap(): {
        model: {
            [modelName: string]: string;
        };
    };
    buildImportStatements(skipReactImport?: boolean): ImportDeclaration[];
}
